zoukankan      html  css  js  c++  java
  • CodeForces

    D. Block Tower
    time limit per test
    2 seconds
    memory limit per test
    256 megabytes
    input
    standard input
    output
    standard output

    After too much playing on paper, Iahub has switched to computer games. The game he plays is called "Block Towers". It is played in a rectangular grid with n rows and m columns (it contains n × m cells). The goal of the game is to build your own city. Some cells in the grid are big holes, where Iahub can't build any building. The rest of cells are empty. In some empty cell Iahub can build exactly one tower of two following types:

    1. Blue towers. Each has population limit equal to 100.
    2. Red towers. Each has population limit equal to 200. However, it can be built in some cell only if in that moment at least one of the neighbouring cells has a Blue Tower. Two cells are neighbours is they share a side.

    Iahub is also allowed to destroy a building from any cell. He can do this operation as much as he wants. After destroying a building, the other buildings are not influenced, and the destroyed cell becomes empty (so Iahub can build a tower in this cell if needed, see the second example for such a case).

    Iahub can convince as many population as he wants to come into his city. So he needs to configure his city to allow maximum population possible. Therefore he should find a sequence of operations that builds the city in an optimal way, so that total population limit is as large as possible.

    He says he's the best at this game, but he doesn't have the optimal solution. Write a program that calculates the optimal one, to show him that he's not as good as he thinks.

    Input

    The first line of the input contains two integers n and m (1 ≤ n, m ≤ 500). Each of the next n lines contains m characters, describing the grid. The j-th character in the i-th line is '.' if you're allowed to build at the cell with coordinates (i, j) a tower (empty cell) or '#' if there is a big hole there.

    Output

    Print an integer k in the first line (0 ≤ k ≤ 106) — the number of operations Iahub should perform to obtain optimal result.

    Each of the following k lines must contain a single operation in the following format:

    1. «B x y» (1 ≤ x ≤ n, 1 ≤ y ≤ m) — building a blue tower at the cell (x, y);
    2. «R x y» (1 ≤ x ≤ n, 1 ≤ y ≤ m) — building a red tower at the cell (x, y);
    3. «D x y» (1 ≤ x ≤ n, 1 ≤ y ≤ m) — destroying a tower at the cell (x, y).

    If there are multiple solutions you can output any of them. Note, that you shouldn't minimize the number of operations.

    Examples
    input
    2 3
    ..#
    .#.
    output
    4
    B 1 1
    R 1 2
    R 2 1
    B 2 3
    input
    1 3
    ...
    output
    5
    B 1 1
    B 1 2
    R 1 3
    D 1 2
    R 1 2

     题目链接

    题意 

      给一个n*m的方格,其中有障碍‘#’和空地‘ . ’,可以在空地上建房子,B房子价值100,R房子价值200(R房子必须建在B房子旁边),此外,还能摧毁房子并建上新的房子。问在这样一张地图上如何使建房子的收益最大?不限制步数。

    分析 

      由于不限制步数,我们可以用比较取巧的方法,即每个联通块只建一座B房子,其余都是R房子。这是可以实现的,首先把空地全部涂上B,再从边界一边拆B一边建R,最后只会剩下一个B。这个边界的寻找比较麻烦,我们考虑dfs,深度搜索联通块到底再回溯摧毁B建R。

    #include<iostream>
    #include<cstdio>
    #include<cmath>
    #include<cstdlib>
    #include<algorithm>
    #include<cstring>
    #include <queue>
    using namespace std;
    typedef long long LL;
    const int maxn = 1e6+5;
    const int mod = 772002+233;
    typedef pair<int,int> pii;
    #define X first
    #define Y second
    #define pb push_back
    #define mp make_pair
    #define ms(a,b) memset(a,b,sizeof(a))
    char res[maxn];
    vector<pair<int,int> > v;
    char mg[505][505];
    
    int k=0;
    int n,m;
    void add(char a,int x,int y){
    
        res[k++]=a;
        v.push_back(make_pair(x,y));
        mg[x][y]=a;
    //    cout<<ans<<endl;
    }
    int dir[4][2]={
        {1,0},{-1,0},
        {0,1},{0,-1}
    };
    void dfs(int x,int y,int dep){
        add('B',x,y);
        for(int i=0;i<4;i++){
            int dx=x+dir[i][0];
            int dy=y+dir[i][1];
            if(dx<1||dx>n||dy<1||dy>m) continue;
            if(mg[dx][dy]=='.')
                dfs(dx,dy,dep+1);
        }
        if(dep){
            add('D',x,y);
            add('R',x,y);
        }
    }
    int main(){
        scanf("%d%d",&n,&m);
        for(int i=1;i<=n;i++) scanf("%s",mg[i]+1);
        for(int i=1;i<=n;i++){
            for(int j=1;j<=m;j++){
                if(mg[i][j]=='.'){
                    dfs(i,j,0);
                }
            }
        }
        cout<<k<<endl;
        for(int i=0;i<k;i++){
            printf("%c %d %d
    ",res[i],v[i].first,v[i].second);
        }
        return 0;
    }
  • 相关阅读:
    forEach与迭代器
    JavaMap
    java stack
    Java的Iterator迭代器
    JavaScript基础知识汇总
    Http协议总结
    以太坊交易剔重规则
    localhost与127.0.0.1与0.0.0.0
    boost之asio
    调和级数求和
  • 原文地址:https://www.cnblogs.com/fht-litost/p/8549738.html
Copyright © 2011-2022 走看看